#include "shortcut.h"
#include<vector>
#include<cstdio>
#include<cassert>

const static int MIN_N = 3, MAX_N = 250000, MIN_C = -1000000000, MAX_C = 1000000000;

int main() {
    int n;
    std::vector<long long> X, Y;

    assert(scanf("%d",&n)==1);
    assert(n>=MIN_N&&n<=MAX_N);
    X.resize(n); Y.resize(n);
    for (int i=0;i<n;i++) {
        assert(scanf("%lld%lld",&X[i],&Y[i])==2);
        assert(MIN_C<=X[i]&&X[i]<=MAX_C&&MIN_C<=Y[i]&&Y[i]<=MAX_C);
    }
    long long res = shortcut(n,X,Y);
    printf("%lld\n",res);

    return 0;
}
